HDU 4003 Find Metal Mineral (树形dp)

来源:互联网 发布:涂鸦照片的软件 编辑:程序博客网 时间:2024/05/01 03:24

Find Metal Mineral

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65768/65768 K (Java/Others)
Total Submission(s): 3510    Accepted Submission(s): 1634

Problem Description
Humans have discovered a kind of new metal mineral on Mars which are distributed in point‐like with paths connecting each of them which formed a tree. Now Humans launches k robots on Mars to collect them, and due to the unknown reasons, the landing site S of all robots is identified in advanced, in other word, all robot should start their job at point S. Each robot can return to Earth anywhere, and of course they cannot go back to Mars. We have research the information of all paths on Mars, including its two endpoints x, y and energy cost w. To reduce the total energy cost, we should make a optimal plan which cost minimal energy cost.
Input
There are multiple cases in the input.
In each case:
The first line specifies three integers N, S, K specifying the numbers of metal mineral, landing site and the number of robots.
The next n‐1 lines will give three integers x, y, w in each line specifying there is a path connected point x and y which should cost w.
1<=N<=10000, 1<=S<=N, 1<=k<=10, 1<=x, y<=N, 1<=w<=10000.
Output
For each cases output one line with the minimal energy cost.
Sample Input
3 1 11 2 11 3 13 1 21 2 11 3 1
Sample Output
32
Hint
In the first case: 1->2->1->3 the cost is 3;In the second case: 1->2; 1->3 the cost is 2;
Source
The 36th ACM/ICPC Asia Regional Dalian Site —— Online Contest
Recommend
lcy   |   We have carefully selected several similar problems for you:  4001 4007 4006 4009 4008 

题解:树形dp。设dp[ i ][ j ]表示对于以 i 结点为根结点的子树,放 j 个机器人所需要的权值和。先将dp[son][0]放进树中,因为dp[son][0]是表示用一个机器人去走完所有子树,最后又回到 pos这个节点,所以花费要乘以2。然后再找到最优的,这里类似于分组背包。

AC代码:
#include<bits/stdc++.h>using namespace std;struct Node{    int now,next,val;}tree[20005];int dp[10005][15];int head[10005];int n,s,k,len;void addedge(int x,int y,int w){    tree[len].now = y;    tree[len].val = w;    tree[len].next = head[x];    head[x] = len++;}void dfs(int root,int fa){        for(int i = head[root];i!=-1;i = tree[i].next)    {        int son = tree[i].now;        if(son == fa)  continue;        dfs(son,root);        for(int j = k; j>=0;j--)        {            //先将dp[son][0]放进树中,因为dp[son][0]是表示用一个机器人去走完所有子树,最后又回到 pos这个节点,所以花费要乘以2            dp[root][j]+=dp[son][0]+2*tree[i].val;            for(int l = 1;l<=j;l++)//再找到更优的,就是分组背包             dp[root][j] = min(dp[root][j],dp[root][j-l]+dp[son][l]+l*tree[i].val);        }    }}int main(){    int i,x,y,w;    while(~scanf("%d%d%d",&n,&s,&k))    {        len = 0;        memset(head,-1,sizeof(head));        memset(dp,0,sizeof(dp));        for(i = 1;i<n;i++)        {            scanf("%d%d%d",&x,&y,&w);            addedge(x,y,w);            addedge(y,x,w);        }        dfs(s,0);        printf("%d\n",dp[s][k]);    }    return 0;}
WA:
#include<bits/stdc++.h>#include<vector>using namespace std;vector<int> V[20010];//dp[i][j]表示对于以i结点为根结点的子树,放j个机器人所需要的权值和。 int dp[20010][30];int val[20010];int n,s,k;void dfs(int root,int fa){        for(int i=0; i< V[root].size();i++)    {        int son=V[root][i];        if(son==fa)continue;        dfs(son,root);        for(int j=k;j>=0;--j)        {            //先将dp[son][0]放进树中,因为dp[son][0]是表示用一个机器人去走完所有子树,最后又回到 pos这个节点,所以花费要乘以2             dp[root][j]+=dp[son][0]+ 2*val[i];            //再找到更优的            for(int l=1;l<=j;l++)             {                dp[root][j] = min(dp[root][j],dp[root][j-l]+dp[son][l]+l*val[i]);            }        }    }}int main(){    int x,y;    while(~scanf("%d%d%d",&n,&s,&k))    {        for(int i=0;i<n;i++) V[i].clear();        memset(dp,0,sizeof(dp));        for(int i=0;i<n-1;i++)        {            scanf("%d%d%d",&x,&y,&val[i]);            V[x].push_back(y);            V[y].push_back(x);        }        dfs(s,0);        printf("%d\n",dp[s][k]);    }    return 0;}


2 0
原创粉丝点击